[Vertex shader]

void main(void)
{	
	texCoord = gl_MultiTexCoord0;
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
}

[Fragment shader]

uniform sampler2D texture;
uniform float h;

void main () 
{
  const float r = 0.23; // Stability criterion. r = eps*dT/dX*dY 

  
  // Read the neighboring texture values
  vec4 u =    texture2D(texture, gl_TexCoord[0].xy);
  vec4 u_pj = texture2D(texture, gl_TexCoord[0].xy + vec2(h,0.0));
  vec4 u_mj = texture2D(texture, gl_TexCoord[0].xy - vec2(h,0.0));
  vec4 u_ip = texture2D(texture, gl_TexCoord[0].xy + vec2(0.0,h));
  vec4 u_im = texture2D(texture, gl_TexCoord[0].xy - vec2(0.0,h));

  // Sum them together
  vec4 result = (1.0-4.0*r)*u + r*(u_pj + u_mj + u_ip + u_im);

  // Output the result to the framebuffer
  gl_FragColor = result;
}