/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: OnScreenRenderTarget.hpp,v 1.8 2005/09/26 15:07:00 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#ifndef _SHALLOWS_ONSCREENRENDERTARGET
#define _SHALLOWS_ONSCREENRENDERTARGET

#include "shallows/config.h"

#include <vector>
#include "shallows/RenderTarget.hpp"
namespace shallows {

   /** \brief Render target for on screen rendering.
    *
    *  Provides the necessary functionality to allow on
    *  screen rendering, including multiple
    *  render targets with Program class.
    */
class  DllExport OnScreenRenderTarget : public RenderTarget
{
public:
   /** The constructor takes an GLenum as argument, describing
       the buffer to use, usually GL_BACK_LEFT */
   OnScreenRenderTarget(unsigned int buff);
   virtual ~OnScreenRenderTarget();

   /** Returns the enum to use to set ReadBuffer or DrawBuffer. 
    *  This enum is set by the constructor
    **/
   virtual unsigned int getLastBufferEnum() const;

  private:
  
   void operator=(const OnScreenRenderTarget &b);
   unsigned int buff_enum_;
   unsigned int width_;
   unsigned int height_;
};
} // namespace shallows

#endif // _SHALLOWS_ONSCREENRENDERTARGET

