/**********************************************************************
 * 
 *  File: Texture1D.hpp
 * 
 *  Created: 22. September 2005
 *
 *  Version: $Id: Texture1D.hpp,v 1.1 2005/10/07 12:24:38 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	         Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	         Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#ifndef _SHALLOWS_TEXTURE_1D_HPP_
#define _SHALLOWS_TEXTURE_1D_HPP_
#include "shallows/config.h"

#include "shallows/Texture.hpp"
namespace shallows {

class  DllExport Texture1D :public shallows::Texture
{

public:

  Texture1D(int internalFormat, 
            unsigned int width, 
            int format, 
            int type, 
            const void *pixels);

  Texture1D(int internalFormat, 
            unsigned int width, 
            unsigned int textureID);

  virtual ~Texture1D();

  unsigned int getWidth() const;
  virtual void bind() const;
  int getInternalFormat() const;
  void validateSamplerType(const std::string &s) const;

private:

  unsigned int width_;
  int internalFormat_;

}; // Texture1D

} // end namespace Shallows


#endif // _SHALLOWS_TEXTURE_2D_HPP_
