/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: CgProgramImpl.hpp,v 1.5 2005/09/14 13:17:55 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
 
 
#ifndef _CGPROGRAMIMPL_HPP_
#define _CGPROGRAMIMPL_HPP_
#include "shallows/config.h"

#if defined(HAVE_CG) && defined(HAVE_CGGL)

#include "shallows/CgProgram.hpp"
#include "shallows/internal/GLIncludes.hpp"

namespace shallows {
   class Texture;
	// class CgProgram; // Forward declaration;
namespace internal {
	class CgShader; // Forward declaration;
	
class CgProgramImpl {
	CgProgramImpl( shallows::CgProgram& parent );
private:
	friend class shallows::CgProgram;
	
	typedef std::auto_ptr<internal::CgShader> pCgShader;
	pCgShader vertexShader_;
  	pCgShader fragmentShader_;
	
	pCgShader initShader( pCgShader shader, internal::Shader::ShaderType type,
		CGcontext context, CGprofile profile, std::string source );
	
	CGparameter validateTexture( const char* name,
				const Texture &texture ) const;
	CGparameter validateUniform( const char *name ) const;
	CGparameter validateAttrib( const char *name ) const;

	CGcontext context_;
    CGprofile vertexProfile_;
  	CGprofile fragmentProfile_;
  	
  	shallows::CgProgram& parent_;
    
    void buildUniformsMap();
};

} // namespace internal
} // namespace shallows
#endif // HAVE_CG
#endif //_CGPROGRAMIMPL_HPP_
