/**********************************************************************
 * 
 *  File: CgShader.hpp
 * 
 *  Created: 20050623
 *
 *  Version: $Id: CgShader.hpp,v 1.5 2005/09/14 13:17:55 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#ifndef _CG_SHADER_H_
#define _CG_SHADER_H_
#include "shallows/config.h"

#if defined(HAVE_CG) && defined(HAVE_CGGL)

#include "shallows/internal/Shader.hpp"
#include "shallows/internal/GLIncludes.hpp"
#include "shallows/Program.hpp"

namespace shallows {
namespace internal {
	
class CgShader : public Shader
{

private:

  CgShader();

protected:
  CGprogram shader_;
  CGprofile profile_;
  CGcontext context_;


public:
  CgShader(ShaderType shaderType, CGcontext context, CGprofile profile);
  virtual ~CgShader();

  virtual bool read(std::string shaderText);
  
  shallows::Program::NameTypeMap getUniformsMap();
  void enable();
  CGprogram getShaderID();
};

} // namespace internal
} // namespace shallows 
#endif // HAVE_CG
#endif // _CG_SHADER_H_
 
