/**********************************************************************
 * 
 *  File: GLIncludes.hpp
 * 
 *  Created:
 *
 *  Version: $Id: GLIncludes.hpp,v 1.7 2005/09/14 13:17:55 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/



#ifndef _GLINCLUDES_HPP_
#define _GLINCLUDES_HPP_

#include "shallows/config.h"

#ifdef _WIN32
#include <windows.h>
#include <GL/gl.h>

#elif defined(UNIX)
#include <GL/gl.h>
#define GL_GLEXT_PROTOTYPES 1
#else
#error "Unknown platform"
#endif

#if defined(HAVE_CG) && defined(HAVE_CGGL)
#include <Cg/cg.h>
#include <Cg/cgGL.h>
#endif

//#include "shallows/internal/glext.h"

#include "shallows/internal/ShallowsExt.hpp"

#endif // _GLINCLUDES_HPP_
