/**********************************************************************
 * 
 *  File: GLShader.hpp
 * 
 *  Created:
 *
 *  Version: $Id: GLShader.hpp,v 1.5 2005/09/23 13:35:08 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
 
#ifndef _GL_SHADER_HPP_
#define _GL_SHADER_HPP_

#include "shallows/config.h"
#include "shallows/internal/Shader.hpp"

namespace shallows {
namespace internal {


class  DllExport GLShader : public Shader
{

private:
  GLShader();

protected:
  unsigned int shader_;
	
public:
  GLShader(ShaderType shaderType);
  virtual ~GLShader();

  virtual bool read(std::string shaderText);

  unsigned int getShaderID() const;
};

} //namespace internal
} // namespace shallows
#endif // _GL_SHADER_H_
 
