/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: Shader.hpp,v 1.5 2005/09/23 13:35:08 trondrh Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#ifndef _SHADER_HPP_
#define _SHADER_HPP_
#include "shallows/config.h"

#include <string>
namespace shallows {
namespace internal {

class DllExport Shader
{
public:

  enum ShaderType {VertexShader, FragmentShader};

  Shader(ShaderType shaderType);
  virtual ~Shader();
  
  /** Reads a shader from a string. Replaces the source code in a shader object and compiles the shader object.
  \param shaderText String containing the shader code.
  \return bool      Everything went OK. */
  virtual bool read(std::string shaderText) = 0;

protected:
  Shader();

  ShaderType shaderType_;

};
} // namespace internal
} // namespace shallows

#endif // _SHADER_H_
 
