/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: utils.hpp,v 1.2 2005/09/23 10:31:56 josse77 Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *       Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *       Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#ifndef SHALLOWS_UTILS_HPP_
#define SHALLOWS_UTILS_HPP_

/** \file utils.hpp Convenience file to include all utility headers. */
#include "shallows/utils/Image.hpp"
#include "shallows/utils/imageCreation.hpp"
#include "shallows/utils/readBuffer.hpp"
#include "shallows/utils/textureCreation.hpp"
#include "shallows/utils/Timer.hpp"
#include "shallows/utils/utilsexcept.hpp"

namespace shallows {
 
/* Just to generate utils namespace documentation.*/

/** \namespace shallows::utils 
 * \brief shallows::utils contains handy utility functions for developing GPGPU applications.
 *  
 *  Members of this namespace might reference external libraries, and the API is
 *  more prone to change over time than the basic shallows API.
 */
namespace utils {
}
}
#endif /*UTILS_HPP_*/
