/**********************************************************************
 * 
 *  File: utilsexcept.hpp
 * 
 *  Created: Jul 14, 2005
 *
 *  Version: $Id: utilsexcept.hpp,v 1.5 2005/09/26 12:24:35 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#ifndef _UTILSEXCEPT_HPP_
#define _UTILSEXCEPT_HPP_

/** \file utilsexcept.hpp
 *  This file contains exceptions that could be thrown by the
 *  shallows::utils namespace.
 */
#include "shallows/config.h"

#include "shallows/shallowsexcept.hpp"
#include <string>

namespace shallows {
namespace utils {

/** \brief Exception class. 
 *
 *  not_supported is thrown if a function is called that depends on an external
 *  library that is not present. This is typical for the functions in 
 *  imageCreation.hpp .
 */ 
class  not_supported : public shallows_runtime_error {
public:
    not_supported( const std::string& arg ) : shallows_runtime_error( arg ) {};
};
    
} // namespace utils
} // namespace shallows
#endif //_UTILSEXCEPT_HPP_
