/**********************************************************************
 * 
 *  File: OnScreenBuffer.cpp
 * 
 *  Created:
 *
 *  Version: $Id: OnScreenBuffer.cpp,v 1.9 2005/11/25 11:18:16 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#include "shallows/OnScreenBuffer.hpp"

#include "shallows/internal/GLIncludes.hpp"
#include "shallows/shallows.hpp"
#include "shallows/shallowsexcept.hpp"
#include "shallows/Texture2D.hpp"
#include "shallows/RenderTarget.hpp"
#include "shallows/OnScreenRenderTarget.hpp"
using namespace shallows::internal;

namespace shallows {

OnScreenBuffer::OnScreenBuffer() : drawBuffers_(1)
{
   CHECK_GL_DEBUG;
   drawBuffers_[0]=static_cast<unsigned int>(GL_BACK_LEFT);
}
   
OnScreenBuffer::~OnScreenBuffer()
{
}
/*
void OnScreenBuffer::attachRenderTarget(RenderTarget &r, int colBufId)
{
   if (colBufId>1)
   {
      
   }

   validateRenderTarget(r);
   activate();
   r.bindToCurrentFrameBuffer(0);
   CHECK_GL_DEBUG;
}
*/


void OnScreenBuffer::validateRenderTarget(const RenderTarget &r) const
{
   const OnScreenRenderTarget *wrt = 
      dynamic_cast<const OnScreenRenderTarget* > (&r);
   if (wrt==0)
   {
      throw 
	 std::invalid_argument("Cannot attach RenderTarget to WindowinBuffer");
   }
}



void OnScreenBuffer::validateCompleteness() const
{
}

void OnScreenBuffer::operator=(const OnScreenBuffer &b)
{ ; }

void OnScreenBuffer::activate()
{
   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
   CHECK_GL_DEBUG;
}

void OnScreenBuffer::setActive()
{
   glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
}

} // namespace shallows
