/**********************************************************************
 * 
 *  File: Texture.cpp 
 * 
 *  Created: 04. July 2005
 *
 *  Version: $Id: Texture.cpp,v 1.2 2005/09/05 11:29:00 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	         Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	         Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#include "shallows/shallows.hpp"
#include "shallows/internal/GLIncludes.hpp"
#include "shallows/shallowsexcept.hpp"
#include "shallows/Texture.hpp"

namespace shallows {

Texture::Texture(unsigned int textureID) : textureID_(textureID)
{
   owned_=false;
   if (textureID_==0)
   {
      glGenTextures(1, &textureID_);
      owned_=true;
      if(textureID_ == 0) 
	 throw std::runtime_error("Could not create texture ID");
   }
}

Texture::~Texture()
{
  if (textureID_!=0 && owned_)
    glDeleteTextures(1, &textureID_);
}

unsigned int Texture::getTextureID() const
{
   return textureID_;
}


} // end namespace Shallows
