/**********************************************************************
 * 
 *  File: FrameBufferTest.hpp
 * 
 *  Created:
 *
 *  Version: $Id: FrameBufferTest.hpp,v 1.8 2005/09/15 09:16:17 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#ifndef _FRAMEBUFFERTEST_HPP_
#define _FRAMEBUFFERTEST_HPP_

#include <cppunit/extensions/HelperMacros.h>

namespace test
{

class FrameBufferTest : public CPPUNIT_NS::TestFixture 
{
	CPPUNIT_TEST_SUITE( FrameBufferTest );
	CPPUNIT_TEST( construction );
	CPPUNIT_TEST( activate );
	CPPUNIT_TEST( deactivate );
	CPPUNIT_TEST( attach2DTexture );
	CPPUNIT_TEST( MRT );
        CPPUNIT_TEST( validateCompleteness );
        CPPUNIT_TEST( depthOnly );
        CPPUNIT_TEST( depthAndColor );
	CPPUNIT_TEST_SUITE_END();
	
public:
	FrameBufferTest();
	virtual ~FrameBufferTest();
	void setUp();
	
protected:
        void construction();
   void activate();
   void deactivate(); 
   void attach2DTexture(); 
   void MRT(); 
   void validateCompleteness();
   void depthAndColor();
   void depthOnly();
};

}; // namespace test

#endif //_FRAMEBUFFERTEST_HPP_
