/**********************************************************************
 * 
 *  File: GLProgramTest.hpp
 * 
 *  Created:
 *
 *  Version: $Id: GLProgramTest.hpp,v 1.10 2005/09/06 16:26:31 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#ifndef _GLPROGRAMTEST_HPP_
#define _GLPROGRAMTEST_HPP_

#include <cppunit/extensions/HelperMacros.h>

namespace test
{

class GLProgramTest : public CPPUNIT_NS::TestFixture 
{
	CPPUNIT_TEST_SUITE( GLProgramTest );
	CPPUNIT_TEST( construction );
	CPPUNIT_TEST( read );
	CPPUNIT_TEST( setParam );
        CPPUNIT_TEST( setInputTexture );
   CPPUNIT_TEST( runSimpleProg );
   CPPUNIT_TEST( runSimpleProgOnScreenBuffer );
   CPPUNIT_TEST( runSimpleProgReadback );
   CPPUNIT_TEST( activate );
   CPPUNIT_TEST( setInputeTextureToTexunit );
	CPPUNIT_TEST_SUITE_END();
	
public:
	GLProgramTest();
	virtual ~GLProgramTest();
	void setUp();
	
protected:
	void construction();
	void read();
	void setParam();
	void setInputTexture();
   void runSimpleProg();
   void runSimpleProgOnScreenBuffer();
   void runSimpleProgReadback();
   void setInputeTextureToTexunit();

   void activate();

};

}; // namespace test

#endif //_GLPROGRAMTEST_HPP_
