/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: Texture2DTest.cpp,v 1.1 2005/07/11 14:54:30 jami Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#include "Texture2DTest.hpp"
#include "shallows/shallowsexcept.hpp"
#include "shallows/internal/GLIncludes.hpp"

#include "shallows/Texture2D.hpp"
#include "shallowstesting.hpp"
#include <string>
#include <cassert> 
#include <iostream>
#include <stdexcept>

using namespace std;

namespace test
{

CPPUNIT_TEST_SUITE_REGISTRATION( Texture2DTest );

Texture2DTest::Texture2DTest()
{
}

Texture2DTest::~Texture2DTest()
{
}


void
Texture2DTest::setUp() {
	initGlut();
}

void
Texture2DTest::construction() {
   CPPUNIT_ASSERT_NO_THROW( shallows::Texture2D tex(GL_RGBA_FLOAT32_ATI,
						    4, 4, 
						    GL_RGBA,
						    GL_FLOAT, 
						    (const float *)0));
   CPPUNIT_ASSERT_THROW( shallows::Texture2D tex(GL_FLOAT,
						 4, 4, 
						 GL_RGBA,
						 GL_FLOAT, 
						 (const float *)0),
			 std::runtime_error);
}


} // namespace test

