/**********************************************************************
 * 
 *  File: 
 * 
 *  Created:
 *
 *  Version: $Id: WindowingBufferTest.cpp,v 1.2 2005/07/18 15:17:01 jami Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/

#include "WindowingBufferTest.hpp"
#include "shallows/OnScreenBuffer.hpp"
#include "shallows/OnScreenRenderTarget.hpp"
#include "shallows/shallowsexcept.hpp"
#include "shallows/internal/GLIncludes.hpp"
#include "shallows/utils/textureCreation.hpp"

#include "shallows/Texture2D.hpp"
#include "shallowstesting.hpp"
#include "shallows/RenderTexture2D.hpp"
#include <string>
#include <cassert> 
#include <iostream>
#include <stdexcept>

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

using namespace std;

namespace test
{

CPPUNIT_TEST_SUITE_REGISTRATION( WindowingBufferTest );

WindowingBufferTest::WindowingBufferTest()
{
}

WindowingBufferTest::~WindowingBufferTest()
{
}


void
WindowingBufferTest::setUp() {
	initGlut();
}

void
WindowingBufferTest::construction() {
   CPPUNIT_ASSERT_NO_THROW( shallows::OnScreenBuffer B );	
   CPPUNIT_ASSERT_NO_THROW( shallows::OnScreenRenderTarget RT(GL_BACK_LEFT) );	
}



} // namespace test

