/**********************************************************************
 * 
 *  File: FrameBufferTest.hpp
 * 
 *  Created:
 *
 *  Version: $Id: readBufferTest.hpp,v 1.2 2005/09/14 10:15:38 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	     Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	     Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#ifndef _READBUFFERTEST_HPP_
#define _READBUFFERTEST_HPP_

#include <cppunit/extensions/HelperMacros.h>

namespace test
{

class readBufferTest : public CPPUNIT_NS::TestFixture 
{
	CPPUNIT_TEST_SUITE( readBufferTest );
   	CPPUNIT_TEST( readDefaultFrameBuffer );
   	CPPUNIT_TEST( readOffScreenFrameBuffer );
   	CPPUNIT_TEST( readOnScreenFrameBuffer );
   	CPPUNIT_TEST( readRenderBuffer );

	CPPUNIT_TEST_SUITE_END();
	
public:
	readBufferTest();
	virtual ~readBufferTest();
	void setUp();
	
protected:
   void readDefaultFrameBuffer ();
   void readOffScreenFrameBuffer ();
   void readOnScreenFrameBuffer ();
   void readRenderBuffer ();
  
};

}; // namespace test

#endif //_READBUFFERTEST_HPP_
