/**********************************************************************
 * 
 *  File: Texture2D.hpp
 * 
 *  Created: 23. June 2005
 *
 *  Version: $Id: shallowstesting.cpp,v 1.4 2005/09/26 11:36:29 jonhjelm Exp $
 *
 *  Authors: Trond R. Hagen <trr@sintef.no>, 
 *	         Jon Mikkelsen Hjelmervik <jami@sintef.no>,
 *	         Johan S. Seland <johans@ifi.uio.no>
 *
 *  This file is part of the Shallows library.
 *  Copyright (C) 2005 by SINTEF.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 * 
 *  For using Shallows with software that can not be combined with the
 *  GNU GPL, please contact SINTEF for aquiring a commercial license
 *  and support.
 *
 *  SINTEF, Pb 124 Blindern, N-0314 Oslo, Norway
 *  http://www.sintef.no
 *********************************************************************/
#include <iostream>
#include <stdlib.h>
#include "shallowstesting.hpp"

#include "shallows/shallows.hpp"
#include <cassert>

namespace test
{
void initGlut () {
    static bool initialized = false;

	if (!initialized) {
		int argc = 1;
		char argv[]="shallowtesting";
		char *argg=argv;
	  	glutInit (&argc, &argg);
	  	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	  	glutInitWindowSize (256, 256);
		const int windowID = glutCreateWindow ("baseglutwindow");
		assert( windowID > 0 && "Could not create GLUT window." );
    shallows::init_shallows();
	  	initialized = true;
      }
      
	CHECK_GL;
};
    
} // namespace test
